module Language where

import Types
import qualified Data.Map as Map

checkUnique [] ma = (True, "")
checkUnique a ma =
   let item = a !! 0 in
   let key = fst item in
   if Map.member key ma then
       (False, (show key))
   else
      checkUnique (tail a) (Map.insert key (snd item) ma)


type Result = (Bool, String)


onlyEven (Assignment n v) = even v

checkOdd p =
   let evenValues = filter onlyEven (filter isAssignment p) in
   let onlyOdd = length (evenValues) == 0 in
   if onlyOdd then
       (True, "")
   else
       (False, "Have even values: " ++ concat (map show evenValues))


extractPair (Assignment name value) = (name, value)

isAssignment (Assignment _ _) = True
isAssigment _ = False

assignmentsOf p =
   map extractPair (filter isAssignment p)

semanticCheck program = 
   let uniqueVars = checkUnique (assignmentsOf program) Map.empty in
   if (fst uniqueVars) then
      let onlyOddValues = checkOdd program in
      if (fst onlyOddValues) then
         Success program
      else
         SemanticError ("All values must be odd: " ++ (snd onlyOddValues))
   else
      SemanticError ("Variables must be unique: " ++ (snd uniqueVars))
  
