import Test.HUnit
import Types
import Grammar
import Language

sampleInstr = Assignment "xyz" 42

testsTypes = TestList [
    TestCase (assertBool "Sample instruction" ((valueOf sampleInstr) == 42)),
    TestCase (assertBool "Sample instruction" ((idOf sampleInstr) == "xyz"))
  ]

buildTestCaseSyn True input msg =
   TestCase (assertBool ("Should be OK (" ++ msg ++ "): " ++ input) 
                          (compileOK (parse input)))
buildTestCaseSyn False input msg =
   TestCase (assertBool ("Should be wrong (" ++ msg ++ ") " ++ input) 
                          (not (compileOK (parse input))))

testsGrammar = TestList [
     buildTestCaseSyn True "x = 3; y = 5;" "",
     buildTestCaseSyn False "x = 3 y = 5;" "Missing semicolon",
     buildTestCaseSyn False "x = a;" "Illegal value",
     buildTestCaseSyn False "x34 = 5;" "Illegal identifier"
  ]

buildTestCaseSem True input msg =
   TestCase (assertBool ("Should be OK (" ++ msg ++ "): " ++ input) 
                          (compileOK (semanticCheck 
                                   (programOf (parse input)))))
buildTestCaseSem False input msg =
   TestCase (assertBool ("Should be wrong (" ++ msg ++ ") " ++ input) 
                          (not (compileOK (semanticCheck 
                                   (programOf (parse input))))))

testsSemantic = TestList [
     buildTestCaseSem True "x = 3; y = 5;" "",
     buildTestCaseSem False "x = 3; y = 5; y = 1;" "Duplicate variables",
     buildTestCaseSem True "x = 67; y = 5; z = 3;" "",
     buildTestCaseSem False "x = 3; y = 5; z = 4;" "Even values"
  ]

main = do
   putStrLn "Tests on basic types"
   runTestTT testsTypes 
   putStrLn "Tests on the grammar"
   runTestTT testsGrammar
   putStrLn "Semantic tests"
   runTestTT testsSemantic
  